/* =============================================================================
 *
 *  Description: This is a C++ to C Thread Header file for Thread BlinkLED
 *
 * -----------------------------------------------------------------------------
 *  Comments:
 *
 * ===========================================================================*/

#ifndef _BlinkLED_H_
#define _BlinkLED_H_


#define	CLEAR_RTC_IRQS		0x807F		// Write-1-To-Clear all RTC interrupts

// addresses for Port B in Flash A
#define pFlashA_PortB_Dir	(volatile unsigned char *)0x20270007
#define pFlashA_PortB_Data	(volatile unsigned char *)0x20270005
#define	pSDRAM_PTR			(volatile unsigned long *)0x000000

// Function Prototypes
void Setup_Interrupt_Vectors(void);
void Configure_SDRAM(void);
void Configure_Flash(void);
void Configure_Flags(void);
void Configure_RTC(void);
void Configure_Interrupts(void);

#pragma diag(push)
#pragma diag(suppress: 177,401,451,826,831,1462)

#include "VDK.h"
#pragma diag(pop)

#ifdef __ECC__	/* for C/C++ access */
#ifdef __cplusplus
extern "C" void BlinkLED_InitFunction(void**, VDK::Thread::ThreadCreationBlock *);
#else
extern "C" void BlinkLED_InitFunction(void**, VDK_ThreadCreationBlock *);
#endif
extern "C" void BlinkLED_DestroyFunction(void**);
extern "C" int  BlinkLED_ErrorFunction(void**);
extern "C" void BlinkLED_RunFunction(void**);
#endif /* __ECC__ */

#ifdef __cplusplus
#include <new>

class BlinkLED_Wrapper : public VDK::Thread
{
public:
    BlinkLED_Wrapper(VDK::ThreadCreationBlock &t)
        : VDK::Thread(t)
    { BlinkLED_InitFunction(&m_DataPtr, &t); }

    ~BlinkLED_Wrapper()
    { BlinkLED_DestroyFunction(&m_DataPtr); }

    int ErrorHandler()
    { 
      return BlinkLED_ErrorFunction(&m_DataPtr);
     }

    void Run()
    { BlinkLED_RunFunction(&m_DataPtr); }

    static VDK::Thread* Create(VDK::Thread::ThreadCreationBlock &t)
    { return new (t) BlinkLED_Wrapper(t); }
};

#endif /* __cplusplus */
#endif /* _BlinkLED_H_ */

/* ========================================================================== */
