#include <cdefBF533.h>
#include <ccblkfn.h>

#define	pSDRAM_PTR			(volatile unsigned long *)0x000000

void DMA_L1_TO_L3(void);
void Save_Scratchpad(void);
void Save_Core_MMRs(void);

/*                                           {SAL,    SAH,     CONFIG,                                                  XCOUNT, XMOD,   SAL,    SAH,     CONFIG,                                                  XCOUNT, XMOD,   SAL,    SAH,     CONFIG,                                   XCOUNT, XMOD  }*/
#if 0
//OS/Drivers:	8KBytes L1 Code, 8KBytes L1 Data Bank B
section("sdram0") short L3_to_L1_S0_DESC[] = {0x4000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x0800, 0x0004, 0x4000, 0x0001, (FLOW-0x7000)|RESTART|WDSIZE_32|DMAEN,     0x0800, 0x0004};
section("sdram0") short L3_to_L1_D0_DESC[] = {0x0000, 0xFFA0, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x0800, 0x0004, 0x0000, 0xFF90, (FLOW-0x7000)|RESTART|WDSIZE_32|WNR|DMAEN, 0x0800, 0x0004};
section("sdram0") short L1_to_L3_S0_DESC[] = {0x0000, 0xFFA0, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x0800, 0x0004, 0x0000, 0xFF90, (FLOW-0x7000)|RESTART|WDSIZE_32|DMAEN,     0x0800, 0x0004};
section("sdram0") short L1_to_L3_D0_DESC[] = {0x4000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x0800, 0x0004, 0x4000, 0x0001, (FLOW-0x7000)|RESTART|WDSIZE_32|WNR|DMAEN, 0x0800, 0x0004};
#endif

#if 0
//Temp:  56KBytes L1 Code, 16KBytes L1 Data Bank A, 24KBytes L1 Data Bank B 
section("sdram0") short L3_to_L1_S0_DESC[] = {0x4000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x3800, 0x0004, 0xC000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x1000, 0x0004, 0x4000, 0x0001, (FLOW-0x7000)|RESTART|WDSIZE_32|DMAEN,     0x1800, 0x0004};
section("sdram0") short L3_to_L1_D0_DESC[] = {0x0000, 0xFFA0, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x3800, 0x0004, 0x0000, 0xFF80, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x1000, 0x0004, 0x0000, 0xFF90, (FLOW-0x7000)|RESTART|WDSIZE_32|WNR|DMAEN, 0x1800, 0x0004};
section("sdram0") short L1_to_L3_S0_DESC[] = {0x0000, 0xFFA0, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x3800, 0x0004, 0x0000, 0xFF80, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x1000, 0x0004, 0x0000, 0xFF90, (FLOW-0x7000)|RESTART|WDSIZE_32|DMAEN,     0x1800, 0x0004};
section("sdram0") short L1_to_L3_D0_DESC[] = {0x4000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x3800, 0x0004, 0xC000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x1000, 0x0004, 0x4000, 0x0001, (FLOW-0x7000)|RESTART|WDSIZE_32|WNR|DMAEN, 0x1800, 0x0004};
#endif

#if 1
//Blink Example:  32kBytes L1 Code, 32KBytes L1 Data Bank A, 32KBytes L1 Data Bank B
section("sdram0") short L3_to_L1_S0_DESC[] = {0x4000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x2000, 0x0004, 0xC000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x2000, 0x0004, 0x4000, 0x0001, (FLOW-0x7000)|RESTART|WDSIZE_32|DMAEN,     0x2000, 0x0004};
section("sdram0") short L3_to_L1_D0_DESC[] = {0x0000, 0xFFA0, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x2000, 0x0004, 0x0000, 0xFF80, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x2000, 0x0004, 0x0000, 0xFF90, (FLOW-0x7000)|RESTART|WDSIZE_32|WNR|DMAEN, 0x2000, 0x0004};
section("sdram0") short L1_to_L3_S0_DESC[] = {0x0000, 0xFFA0, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x2000, 0x0004, 0x0000, 0xFF80, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN,     0x2000, 0x0004, 0x0000, 0xFF90, (FLOW-0x7000)|RESTART|WDSIZE_32|DMAEN,     0x2000, 0x0004};
section("sdram0") short L1_to_L3_D0_DESC[] = {0x4000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x2000, 0x0004, 0xC000, 0x0000, (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN, 0x2000, 0x0004, 0x4000, 0x0001, (FLOW-0x7000)|RESTART|WDSIZE_32|WNR|DMAEN, 0x2000, 0x0004};
#endif

section("sdram0") void Save_System(void)
{
    DMA_L1_TO_L3();
   	Save_Scratchpad();
   	Save_Core_MMRs();

//Wait until L1 Memory DMA is complete   
    while(*pMDMA_D0_IRQ_STATUS & DMA_RUN);
    *pMDMA_D0_IRQ_STATUS = 0x1;    
}

section("sdram0") void DMA_L1_TO_L3(void)
{ 
    *pMDMA_S0_CURR_DESC_PTR = &L1_to_L3_S0_DESC;
    *pMDMA_D0_CURR_DESC_PTR = &L1_to_L3_D0_DESC;
    *pMDMA_S0_CONFIG = (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|DMAEN;
    *pMDMA_D0_CONFIG = (FLOW-0x3000)|(NDSIZE-0x400)|RESTART|WDSIZE_32|WNR|DMAEN;
    
    //Save pointer to L3-to-L1 DMA Descriptor List to location 0x3FF8
    *(pSDRAM_PTR+0xFFE) = (unsigned long)&L3_to_L1_S0_DESC;
}

section("L1_code") void Save_Scratchpad(void)
{ 
    long temp;
    int i;
    unsigned long *pScratchpad_ptr;
    unsigned long *pSdram_ptr;
    
    pScratchpad_ptr = (unsigned long *)0xFFB00000;
    pSdram_ptr = (unsigned long *)0x1C000;    
    
    for(i=0; i<1024; i++)
    {
    	temp = *(pScratchpad_ptr++);
    	*(pSdram_ptr++) = temp;
    }
}

section("L1_code") void Save_Core_MMRs(void)
{
    long temp;
    int i;
    unsigned long *pCore_MMR_ptr;
    unsigned long *pSdram_ptr;   
    
//Save Event Vector Table
    pCore_MMR_ptr = (unsigned long *)0xFFE02000;
    pSdram_ptr = (unsigned long *)0x1D000;
    for(i=0; i<16; i++)
    {
    	temp = *(pCore_MMR_ptr++);
    	*(pSdram_ptr++) = temp;
    }
    
//Save IMASK
	pCore_MMR_ptr = (unsigned long *)0xFFE02104;
	temp = *(pCore_MMR_ptr++);
	*(pSdram_ptr++) = temp;
}

